<?php

require_once('../init.php');

function build_simple_query($mask, $refcol, $column)
{
  $sql = sprintf("UPDATE %s SET %s = %d WHERE %s = %d",
		 $mask['table'],
		 $column,
		 $_POST['value'],
		 $refcol,
		 $_POST['reference']);

  return $sql;
}

function build_query($mask, $refcol, $column)
{
  global $db;

  $where = '';
  $keys = array_keys($mask['list']);
  for ($i=0; $i<count($keys); $i++)
    if (array_key_exists('filter_'.$i, $_POST)) {
      $filter = explode('|', $_POST['filter_'.$i]);
      if (strlen($where)) $where .= ' AND ';
      if ($filter[0] === 'LIKE') $filter[1] = '%'.$filter[1].'%';
      elseif ($filter[0] === 'EQ') $filter[0] = '=';
      $where .= sprintf("%s %s '%s'",
			empty($mask['list'][$keys[$i]]['sql'])?$keys[$i]:$mask['list'][$keys[$i]]['sql'],
			$filter[0], $filter[1]);
    }

  $sql = sprintf("UPDATE %s SET %s = %d %s",
		 $mask['table'],
		 $column,
		 $_POST['value'],
		 empty($where) ? '' : 'WHERE ' . $where);

  return $sql;
}

function refcol($mask, $column) {
  preg_match('/Rico.TableColumn.checkboxDB\(\s*(\d+)\s*,/', $mask['list'][$column]['control'], $matches);

  $fields = array_keys($mask['list']);
  $colname = $fields[$matches[1]];

  if (array_key_exists('sql', $mask['list'][$colname]))
    $colname = $mask['list'][$colname]['sql'];

  return $colname;
}

if (empty($_POST['table']))
  exit;

db_connect();
if (load_mask(substr($_POST['table'],5)) === false) exit;

$fields = array_keys($mask['list']);
$column = $fields[$_POST['column']];
$refcol = refcol($mask, $column);

if (empty($column)) exit;

if (isset($_POST['reference']))
  $sql = build_simple_query($mask, $refcol, $column);
else 
  $sql = build_query($mask, $refcol, $column);

$sth = $db->query($sql);

if ($sth === false)
  error_log($sql . ': ' . db_error());

?>
