<?php

function tempdir()
{
  $tries = 0;
  while ($tries < 100) {
    $tries++;

    $dir = sys_get_temp_dir() . '/' . substr(md5(time()),0,10);
    if (mkdir($dir,0700) === true)
      return $dir;
  }
  error_log("Cannot create temporary directory in $tries tries");
}

function odt_rebuild($tempdir, $odtfile, $info)
{
  if (!file_exists('/usr/bin/unzip')) {
    error_log('unzip not installed');
    return false;
  }

  if (!file_exists('/usr/bin/zip')) {
    error_log('zip not installed');
    return false;
  }

  $olddir = getcwd();
  mkdir($tempdir . '/odtlab', 0700);
  chdir($tempdir . '/odtlab');

  system("unzip -qq " . $odtfile);
  $files = array();

  if (array_key_exists('images', $info)) {
    foreach ($info['images'] as $img => $src) {
      if (file_exists($src) && file_exists($img)) {
	$files[] = $img;
	if (copy($src, $img) === false)
	  error_log("Fehler beim Kopieren von $src nach $img");
      }
    }
  }

  if (array_key_exists('fields', $info)) {
    $files[] = 'content.xml';
    $content = file_get_contents('content.xml');
    $pattern = array();
    $replacement = array();

    foreach ($info['fields'] as $name => $value) {
      $pattern[] = '/(<text:user-field-decl office:value-type="[^"]+" office:string-value=")[^"]*(" text:name="'.$name.'"\/>)/';
      $replacement[] = '${1}'.$value.'${2}';

      $pattern[] = '/(<text:user-field-get text:name="'.$name.'">)[^<]*(<\/text:user-field-get>)/';
      $replacement[] = '${1}'.$value.'${2}';
    }
    $content = preg_replace($pattern, $replacement, $content);

    file_put_contents('content.xml', $content);
  }

  if (count($files) > 0)
    system("zip -qq -u " . $odtfile . " " . implode(' ', $files));

  system('rm -rf ' . $tempdir . '/odtlab');

  chdir($olddir);
  return true;
}

?>

